//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------


BOOL TForm1::LoadDecryptPDF()
{
	char path[_MAX_PATH];
	GetModulePath(path,"apPDFPasswordRecovery.dll");
	g_hDecryptpdf=LoadLibrary(path);
	if(g_hDecryptpdf==NULL)
		goto Failer;

	pDecryptPDF=(DecryptPDF)GetProcAddress(g_hDecryptpdf,"_DecryptPDF@36");
	if(pDecryptPDF==NULL)
		goto Failer;

	pIsEncryptPDF=(IsEncryptPDF)GetProcAddress(g_hDecryptpdf,"_IsEncryptPDF@4");
	if(pIsEncryptPDF==NULL)
		goto Failer;

	pIsPDFFormat=(IsPDFFormat)GetProcAddress(g_hDecryptpdf,"_IsPDFFormat@4");
	if(pIsPDFFormat==NULL)
		goto Failer;

	return TRUE;
Failer:
	FreeDecryptPDF();
	return FALSE;

}

void TForm1::FreeDecryptPDF()
{
	if(g_hDecryptpdf==NULL)
		return ;
	FreeLibrary(g_hDecryptpdf);
	g_hDecryptpdf=NULL;
}


void TForm1::GetModulePath(char *out_path,char *in_name)
{
	char *p;
	GetModuleFileName(NULL,out_path,256);
	p =strrchr(out_path,'\\');
	p[1]=0;
	strcat(out_path,in_name);
}


void __fastcall TForm1::Button1Click(TObject *Sender)
{
	char srcpath[_MAX_PATH];
	char despath[_MAX_PATH];

	memset(srcpath,0,_MAX_PATH);
	memset(despath,0,_MAX_PATH);


	if(LoadDecryptPDF()==FALSE)
		return ;

	GetModulePath(srcpath,"encrypt1.pdf");

	if(pIsPDFFormat(srcpath)){
		if(pIsEncryptPDF(srcpath)){

			GetModulePath(despath,"decrypt_owner.pdf");
			pDecryptPDF(srcpath,despath,
				"owner",NULL,
				"keywords","subject","title","author","creator");

			GetModulePath(despath,"decrypt_user.pdf");
			pDecryptPDF(srcpath,despath,
				NULL,"user",
				NULL,NULL,NULL,NULL,NULL);

		}
	}	

	GetModulePath(srcpath,"encrypt2.pdf");
	GetModulePath(despath,"decrypt2.pdf");

	pDecryptPDF(srcpath,despath,
					NULL,NULL,
					NULL,NULL,NULL,NULL,NULL);



	FreeDecryptPDF();
}
//---------------------------------------------------------------------------
