

#include <stdio.h>
#include <Windows.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <windowsx.h> 



typedef long (WINAPI *DecryptPDF)(char * inFileName,char *outFileName,
					char *OwnerPassword,char *UserPassword,
					char *keywords,char *subject,char *title,char *author,char *creator );
typedef BOOL (__stdcall *IsEncryptPDF)(char * inFileName);
typedef BOOL (__stdcall *IsPDFFormat)(char * inFileName);


HMODULE				g_hDecryptpdf=NULL;
DecryptPDF			pDecryptPDF;
IsEncryptPDF		pIsEncryptPDF;
IsPDFFormat			pIsPDFFormat;


void	GetModulePath(char *out_path,char *in_name);
BOOL	LoadDecryptPDF(void);
void	FreeDecryptPDF();







BOOL LoadDecryptPDF()
{
	char path[_MAX_PATH];
	GetModulePath(path,"apPDFPasswordRecovery.dll");
	g_hDecryptpdf=LoadLibrary(path);
	if(g_hDecryptpdf==NULL)
		goto Failer;

	pDecryptPDF=(DecryptPDF)GetProcAddress(g_hDecryptpdf,"_DecryptPDF@36");
	if(pDecryptPDF==NULL)
		goto Failer;

	pIsEncryptPDF=(IsEncryptPDF)GetProcAddress(g_hDecryptpdf,"_IsEncryptPDF@4");
	if(pIsEncryptPDF==NULL)
		goto Failer;

	pIsPDFFormat=(IsPDFFormat)GetProcAddress(g_hDecryptpdf,"_IsPDFFormat@4");
	if(pIsPDFFormat==NULL)
		goto Failer;

	return TRUE;
Failer:
	FreeDecryptPDF(); 
	return FALSE;

}

void FreeDecryptPDF()
{
	if(g_hDecryptpdf==NULL)
		return ;
	FreeLibrary(g_hDecryptpdf);
	g_hDecryptpdf=NULL;
}


void GetModulePath(char *out_path,char *in_name)
{
	char *p;
	GetModuleFileName(NULL,out_path,256);
	p =strrchr(out_path,'\\');
	p[1]=0;
	strcat(out_path,in_name);
}



main()
{

	char srcpath[_MAX_PATH];
	char despath[_MAX_PATH];

	memset(srcpath,0,_MAX_PATH);
	memset(despath,0,_MAX_PATH);


	if(LoadDecryptPDF()==FALSE)
		return FALSE;

	GetModulePath(srcpath,"encrypt1.pdf");

	if(pIsPDFFormat(srcpath)){
		if(pIsEncryptPDF(srcpath)){
			
			GetModulePath(despath,"decrypt_owner.pdf");
			pDecryptPDF(srcpath,despath,
				"owner",NULL,
				"keywords","subject","title","author","creator");

			GetModulePath(despath,"decrypt_user.pdf");
			pDecryptPDF(srcpath,despath,
				NULL,"user",
				NULL,NULL,NULL,NULL,NULL);

		}
	}	

	GetModulePath(srcpath,"encrypt2.pdf");
	GetModulePath(despath,"decrypt2.pdf");

	pDecryptPDF(srcpath,despath,
					NULL,NULL,
					NULL,NULL,NULL,NULL,NULL);



	FreeDecryptPDF();
}